"""
Converts a cluster file (as generated by cluster struc) and a DOF file 
 into a new DOF file that generates one structure per cluster
 By default, the cluster center is taken, unless --best is specified, in which case the lowest-energy structure is selected
"""
import sys
from _read_struc import read_struc

cluster = sys.argv[1]
header, structures = read_struc(sys.argv[2])

for h in header: print h

options = sys.argv[3:]
for o in options: 
  assert o in ("--best",), o

clusterlist = []
for line in open(cluster).readlines():
  tmp = line.split()
  if not 'Cluster' in line: continue
  data = [int(truc) for truc in tmp[3:]]  
  if "--best" in options:     
    clusterlist.append(min(data)) #select best scored in cluster
  else:
    clusterlist.append(data[0]) #select cluster center

stnr = 0
st2nr = 0
strucs = {}

for s in structures:
  stnr += 1
  if not stnr in clusterlist:
    continue
  else:
    strucs[stnr] = s

for stnr in clusterlist:
  s = strucs[stnr]
  st2nr += 1
  print "#"+str(st2nr)
  print "##"+str(stnr) + " => cluster"
  l1,l2 = s
  for l in l1: print l
  for l in l2: print l
